// ZipArchiveExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cderr.h"
#include "ZipArchiveExplorer.h"
#include "ZipArchiveExplorerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    SetDlgItemText( IDC_ZLIBVERSION, zlibVersion() );
	
    OSVERSIONINFO osver;
    CString Info;

    osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx( &osver );
    Info.Format( "%s Version %d.%d (Build %d: %s)", osver.dwPlatformId == VER_PLATFORM_WIN32s? "Windows 3.11" : 
                                                   osver.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS? "Windows95/98" : 
                                                   "Windows NT",
                                                   osver.dwMajorVersion, 
                                                   osver.dwMinorVersion,
                                                   osver.dwBuildNumber,
                                                   osver.szCSDVersion );

    SetDlgItemText( IDC_SYSINFO, Info );
	
	return TRUE;  
}



/////////////////////////////////////////////////////////////////////////////
// CZipArchiveExplorerDlg dialog

CZipArchiveExplorerDlg::CZipArchiveExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZipArchiveExplorerDlg::IDD, pParent),
    m_pZipArchive(NULL)
{
	//{{AFX_DATA_INIT(CZipArchiveExplorerDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CZipArchiveExplorerDlg::~CZipArchiveExplorerDlg()
{
    if ( m_pZipArchive != NULL )
        delete m_pZipArchive;
}

void CZipArchiveExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZipArchiveExplorerDlg)
	DDX_Control(pDX, IDC_DELETEFILES, m_btnDeleteFiles);
	DDX_Control(pDX, IDC_CLOSEARCHIVE, m_btnCloseArchive);
	DDX_Control(pDX, IDC_OPERATION, m_ctlOperation);
	DDX_Control(pDX, IDC_CURRENTFILE, m_ctlCurrentFile);
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
	DDX_Control(pDX, IDC_OPENARCHIVE, m_btnOpenArchive);
	DDX_Control(pDX, IDC_NEWARCHIVE, m_btnNewArchive);
	DDX_Control(pDX, IDC_EXTRACTFILES, m_btnExtractFiles);
	DDX_Control(pDX, IDC_ADDFILES, m_btnAddFiles);
	DDX_Control(pDX, IDC_ARCHIVE_CONTENT, m_ctlContent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZipArchiveExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(CZipArchiveExplorerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_NEWARCHIVE, OnNewArchive)
	ON_BN_CLICKED(IDC_OPENARCHIVE, OnOpenArchive)
	ON_BN_CLICKED(IDC_ADDFILES, OnAddFiles)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ARCHIVE_CONTENT, OnArchiveContentItemChanged)
	ON_COMMAND(IDC_CLOSEARCHIVE, OnCloseArchive)
	ON_BN_CLICKED(IDC_EXTRACTFILES, OnExtractFiles)
	ON_NOTIFY(NM_RCLICK, IDC_ARCHIVE_CONTENT, OnRclickArchiveContent)
	ON_COMMAND(IDC_SELECTALL, OnSelectAll)
	ON_BN_CLICKED(IDC_DELETEFILES, OnDeleteFiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZipArchiveExplorerDlg message handlers

BOOL CZipArchiveExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    InitContent();
    UpdateButtonStatus();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CZipArchiveExplorerDlg::InitContent()
{
    m_ctlContent.InsertColumn( columnName, "Name", LVCFMT_LEFT, 100 );
    m_ctlContent.InsertColumn( columnExt, "Ext", LVCFMT_LEFT, 40 );
	m_ctlContent.InsertColumn( columnDate, "Date", LVCFMT_CENTER, 100 );
	m_ctlContent.InsertColumn( columnSizeNorm, "NormSize", LVCFMT_RIGHT, 60 );
    m_ctlContent.InsertColumn( columnSizeComp, "CompSize", LVCFMT_RIGHT, 60 );	    
    m_ctlContent.InsertColumn( columnAttr, "Attr", LVCFMT_CENTER, 30 );
    m_ctlContent.InsertColumn( columnCRC, "CRC32", LVCFMT_LEFT, 60 );
    m_ctlContent.InsertColumn( columnPath, "Path", LVCFMT_LEFT, 90 );
    
    m_ctlContent.SendMessage( LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT );
}

void CZipArchiveExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CZipArchiveExplorerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CZipArchiveExplorerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CZipArchiveExplorerDlg::UpdateButtonStatus()
{
    m_btnCloseArchive.EnableWindow( m_pZipArchive != NULL );
    m_btnAddFiles.EnableWindow( m_pZipArchive != NULL && m_pZipArchive->CanAddFiles() );
    m_btnExtractFiles.EnableWindow( m_pZipArchive != NULL && m_ctlContent.GetSelectedCount() > 0 );    
    m_btnDeleteFiles.EnableWindow( m_pZipArchive != NULL && m_ctlContent.GetSelectedCount() > 0 );            
}

void CZipArchiveExplorerDlg::OnNewArchive() 
{
    static char szFilter[] = "Zip Files (*.zip)|*.zip|All files (*.*)|*.*||";
    CFileDialog dlgOpen( TRUE, "zip", NULL, 
							  OFN_EXPLORER|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST, szFilter,
							  this );        

    CString strTitle( "Create new archive file" );
    dlgOpen.m_ofn.lpstrTitle = strTitle;
    if ( dlgOpen.DoModal() != IDOK )
	    return;
    CString strArchiveName = dlgOpen.GetPathName();    
    
    if ( ::GetFileAttributes(strArchiveName) != 0xffffffff )    // file exists
    {
        CString strMessage;
        strMessage.Format( "Cannot create file %s (file exists)\nOpen existing file?", strArchiveName );
        int nAnswer = MessageBox( strMessage, AfxGetAppName(), MB_YESNOCANCEL|MB_ICONQUESTION );
        if ( nAnswer == IDYES )
        {
            OpenArchive( strArchiveName );
        }
        return;
    }

    CreateArchive( strArchiveName );
}

void CZipArchiveExplorerDlg::OnOpenArchive() 
{
    static char szFilter[] = "Zip Files (*.zip)|*.zip|All files (*.*)|*.*||";
    CFileDialog dlgOpen( TRUE, "zip", NULL, 
							  OFN_EXPLORER|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST, szFilter,
							  this );        

    CString strTitle( "Open existing archive" );
    dlgOpen.m_ofn.lpstrTitle = strTitle;
    if ( dlgOpen.DoModal() != IDOK )
	    return;
    CString strArchiveName = dlgOpen.GetPathName();    
    
    OpenArchive( strArchiveName );
}


bool CZipArchiveExplorerDlg::CreateArchive( const CString& strArchiveName )
{
    if ( m_pZipArchive != NULL )
    {
        delete m_pZipArchive;
    }        
    
    bool bCreated = false;
    try
    {
        m_pZipArchive = new CZipArchive( strArchiveName, true, this );
        bCreated = true;
    }
    catch (...)
    {
        MessageBox( "Archive creation failed.\t", AfxGetAppName(), MB_ICONSTOP );
    }
        
    DisplayTitle();
    DisplayArchiveContent();
    UpdateButtonStatus();
    
    return bCreated;
}
    
bool CZipArchiveExplorerDlg::OpenArchive( const CString& strArchiveName )
{
    if ( m_pZipArchive != NULL )
    {
        delete m_pZipArchive;
    }        

    bool bOpened = false;    
    try
    {
        m_pZipArchive = new CZipArchive( strArchiveName, false, this );
        bOpened = true;
    }
    catch (...)
    {
        MessageBox( "Archive opening failed.\t", AfxGetAppName(), MB_ICONSTOP );
    }

    DisplayTitle();
    DisplayArchiveContent();
    UpdateButtonStatus();
    
    return bOpened;
}

void CZipArchiveExplorerDlg::DisplayTitle()
{
    if ( m_pZipArchive != NULL )
    {
        CString strTitle;
        if ( m_pZipArchive->CanAddFiles() )
            strTitle.Format( "%s - %s", m_pZipArchive->GetName(), AfxGetAppName() );
        else
            strTitle.Format( "%s [Readonly] - %s", m_pZipArchive->GetName(), AfxGetAppName() );        
        SetWindowText( strTitle );
    }
    else
        SetWindowText( AfxGetAppName() );        
}
    
void CZipArchiveExplorerDlg::DisplayArchiveContent()
{
    m_ctlContent.DeleteAllItems();
    
    if ( m_pZipArchive == NULL )
        return;
    
    CWaitCursor wait;
    m_ctlContent.LockWindowUpdate();
    
    for ( int i = 0; i < m_pZipArchive->GetZipFileCount(); i++ )
    {
        const CZipFile& zipFile = m_pZipArchive->GetZipFile( i );
        
        if ( zipFile.GetAttributes() & FILE_ATTRIBUTE_DIRECTORY )
        {
            InsertSubdirectoryItem( i, zipFile );
        }
        else
        {
            InsertFileItem( i, zipFile );
        }
    }
    
    m_ctlContent.UnlockWindowUpdate();
}

void CZipArchiveExplorerDlg::InsertSubdirectoryItem( int nItemPos, const CZipFile& zipFile )
{
    LV_ITEM lvItem;
    ZeroMemory( &lvItem, sizeof(lvItem) );
    lvItem.mask = LVIF_TEXT;
    lvItem.iItem = nItemPos;
    lvItem.iSubItem = 0;
    lvItem.pszText = (LPSTR)(LPCTSTR) zipFile.GetFilename();
    // name
    m_ctlContent.InsertItem( &lvItem );
    // attributes
    m_ctlContent.SetItemText( nItemPos, columnAttr, "dir" );
}

void CZipArchiveExplorerDlg::InsertFileItem( int nItemPos, const CZipFile& zipFile )
{
    LV_ITEM lvItem;
    ZeroMemory( &lvItem, sizeof(lvItem) );
    lvItem.mask = LVIF_TEXT;
    lvItem.iItem = nItemPos;
    lvItem.iSubItem = 0;
    
    char szDir[_MAX_DIR];
    char szFilename[_MAX_FNAME];
    char szExtension[_MAX_EXT];
    _splitpath( zipFile.GetFilename(), NULL, szDir, szFilename, szExtension );
    lvItem.pszText = szFilename;
    // name
    m_ctlContent.InsertItem( &lvItem );
    // extension
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, szExtension );
    // date
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, GetDateTimeAsString(zipFile.GetFileDate(),zipFile.GetFileTime()) );
    // size
    char szFileSize[32];
    ltoa( (long) zipFile.GetUncompressedSize(), szFileSize, 10 );
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, szFileSize );
    ltoa( (long) zipFile.GetCompressedSize(), szFileSize, 10 );
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, szFileSize );
    // attributes
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, GetAttributesAsString(zipFile.GetAttributes()) );
    // crc32
    CString strCRC;
    strCRC.Format( "%08x", zipFile.GetCrc32() );
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, strCRC );
    // path
    m_ctlContent.SetItemText( nItemPos, ++lvItem.iSubItem, szDir );        
}

CString CZipArchiveExplorerDlg::GetDateTimeAsString( const DOSDATE& dosDate, const DOSTIME& dosTime ) const
{
    CString strDate;
    strDate.Format( "%02d/%02d/%04d %02d:%02d", (int) dosDate.day, (int)dosDate.month, (int)dosDate.year + 1980, (int)dosTime.hour, (int)dosTime.minute );
    
    return strDate;
}
    
CString CZipArchiveExplorerDlg::GetAttributesAsString( BYTE bAttributes ) const
{
    CString strAttributes;
    
    strAttributes += bAttributes & FILE_ATTRIBUTE_READONLY? 'r' : '-';
    strAttributes += bAttributes & FILE_ATTRIBUTE_HIDDEN?   'h' : '-';
    strAttributes += bAttributes & FILE_ATTRIBUTE_SYSTEM?   's' : '-';
    strAttributes += bAttributes & FILE_ATTRIBUTE_ARCHIVE?  'a' : '-';
   
    return strAttributes;
}   


void CZipArchiveExplorerDlg::OnAddFiles() 
{
    if ( m_pZipArchive == NULL )  
        return;
    else
        if ( m_pZipArchive->CanAddFiles() == false )
        {
            MessageBox( "Archive is opened in readonly mode, changes are not allowed.", AfxGetAppName(), MB_ICONEXCLAMATION );
            return;
        }

    static char szFilter[] = "All files (*.*)|*.*||";
    CFileDialog dlgOpen( TRUE, "zip", NULL, 
							  OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_ALLOWMULTISELECT, 
                              szFilter,
							  this );        

    CString strTitle( "Add files to archive" );
    dlgOpen.m_ofn.lpstrTitle = strTitle;
    if ( dlgOpen.DoModal() != IDOK )
    {
        DWORD dwError = ::CommDlgExtendedError();
        if ( dwError == FNERR_BUFFERTOOSMALL )
            MessageBox( "Common Dialog bug: Too many filenames.\nSee article Q179372 in MS Knowledge Base", AfxGetAppName(), MB_ICONSTOP );
        return;
    }

    try
    {
        CStringArray arrayFilesToAdd;
        POSITION posFile = dlgOpen.GetStartPosition();    
        while ( posFile != NULL )
        {
            TCHAR szFilename[_MAX_FNAME];
            TCHAR szExtension[_MAX_EXT];
            _splitpath( dlgOpen.GetNextPathName(posFile), NULL, NULL, szFilename, szExtension );
            CString strFileWithoutPath( CString(szFilename) + CString(szExtension) );
            arrayFilesToAdd.Add( strFileWithoutPath );
        }

        CWaitCursor wait;
        m_ctlOperation.SetWindowText( "Pack" );
        m_pZipArchive->Add( arrayFilesToAdd );
    }
    catch ( ... )
    {
        MessageBox( "Adding files to archive failed.", AfxGetAppName(), MB_ICONSTOP );
    }
    
    ResetProgressStatus();
    DisplayArchiveContent();
    UpdateButtonStatus();
}

void CZipArchiveExplorerDlg::ResetProgressStatus()
{
    m_ctlCurrentFile.SetWindowText( "" );
    m_ctlProgress.SetPos( 0 );
    m_ctlOperation.SetWindowText( "Idle" );
}


bool CZipArchiveExplorerDlg::OnArchiveProgress( const CString& strFilename, DWORD dwCurrent, DWORD dwTotal )
{
    m_ctlCurrentFile.SetWindowText( strFilename );
   
    m_ctlProgress.SetRange32( 0, dwTotal );
    m_ctlProgress.SetPos( dwCurrent );

    bool bEscPressed = ProcessQueuedMessages();

    if ( bEscPressed )
    {
        int nAnswer = MessageBox( "Stop processing archive?\t", AfxGetAppName(), MB_YESNOCANCEL|MB_DEFBUTTON2|MB_ICONQUESTION );
        if ( nAnswer == IDYES )
            return false;
    }

    return true;
}
    
bool CZipArchiveExplorerDlg::ProcessQueuedMessages()
{
	MSG msg;
    
    bool bEscPressed = false;
	while ( ::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE) ) 
    { 
		if ( msg.message == WM_KEYDOWN )
		{
			if ( msg.wParam == VK_ESCAPE || msg.wParam == VK_CANCEL )
				bEscPressed = true;    
		}
		// swallow
		if ( msg.message >= WM_KEYFIRST && msg.message <= WM_KEYLAST
			|| msg.message >= WM_MOUSEFIRST && msg.message <= WM_MOUSELAST
			|| msg.message >= WM_NCMOUSEMOVE && msg.message <= WM_NCMBUTTONDBLCLK
			|| msg.message == WM_COMMAND )
		{
			AfxGetApp()->RestoreWaitCursor();
			::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE );
			continue;
		}
		// perform normal message translation and dispatching
        if ( !AfxGetThread()->PumpMessage() ) 
        { 
            ::PostQuitMessage(0); 
            break; 
        } 
	}

    // let MFC do its idle processing
    LONG lIdle = 0;
    while ( AfxGetApp()->OnIdle(lIdle++ ) )
        ;  

    return bEscPressed;
}

void CZipArchiveExplorerDlg::OnArchiveContentItemChanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

    UpdateButtonStatus();    
	
	*pResult = 0;
}

void CZipArchiveExplorerDlg::OnCloseArchive() 
{
    if ( m_pZipArchive != NULL )
    {
        delete m_pZipArchive;
        m_pZipArchive = NULL;
    }
        
    DisplayTitle();
    DisplayArchiveContent();
    UpdateButtonStatus();
}


void CZipArchiveExplorerDlg::OnExtractFiles() 
{
    ASSERT(m_pZipArchive != NULL);
    
    if ( m_pZipArchive == NULL )
        return;
        
    CString strFolder;
    
    if ( BrowseForFolder(strFolder) )
    {
        TCHAR szDir[MAX_PATH];
        ::GetCurrentDirectory( MAX_PATH, szDir );
        ::SetCurrentDirectory( strFolder );
        
        try
        {
            CStringArray arrayFilesToExtract;
            POSITION posItem = m_ctlContent.GetFirstSelectedItemPosition();
            while ( posItem != NULL )
            {
                int nItem = m_ctlContent.GetNextSelectedItem( posItem );
                const CZipFile& zipFile = m_pZipArchive->GetZipFile( nItem );
                arrayFilesToExtract.Add( zipFile.GetFilename() );
            }
            
            CWaitCursor wait;
            m_ctlOperation.SetWindowText( "Extract" );
            m_pZipArchive->Extract( arrayFilesToExtract );
        }
        catch ( ... )
        {
            MessageBox( "Extraction failed.\t", AfxGetAppName(), MB_ICONSTOP );
        }
        ::SetCurrentDirectory( szDir );

        ResetProgressStatus();
        UpdateButtonStatus();
    }
}

int CALLBACK CZipArchiveExplorerDlg::BrowseCallbackProc( HWND hwnd, UINT uMsg, LPARAM lp, LPARAM pData ) 
{
    TCHAR szDir[MAX_PATH];

    switch ( uMsg ) 
    {
        case BFFM_INITIALIZED: 
            if ( GetCurrentDirectory(sizeof(szDir)/sizeof(TCHAR),szDir) )
            {
                ::SendMessage( hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)szDir );
            }
            break;
        case BFFM_SELCHANGED: 
            if ( SHGetPathFromIDList((LPITEMIDLIST) lp ,szDir) ) 
                ::SendMessage( hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir );
            break;
        default:
            break;
    }

    return 0;
}

bool CZipArchiveExplorerDlg::BrowseForFolder( CString& strFolder )
{
    LPMALLOC pMalloc;

    bool bFolderSelected = false;
    if ( SUCCEEDED(SHGetMalloc(&pMalloc)) ) 
    {
        BROWSEINFO bi;
        ZeroMemory( &bi, sizeof(bi) );
        bi.hwndOwner = this->m_hWnd;
        bi.pszDisplayName = 0;
        bi.lpszTitle = "Select extract directory";
        bi.pidlRoot = 0;
        bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
        bi.lpfn = BrowseCallbackProc;

        LPITEMIDLIST pidl = SHBrowseForFolder( &bi );
        if (pidl) 
        {
            LPSTR pszDir = strFolder.GetBufferSetLength( MAX_PATH );
            if ( SHGetPathFromIDList(pidl,pszDir) ) 
            {
                bFolderSelected = true;
            }
            strFolder.ReleaseBuffer();

            pMalloc->Free(pidl); 
            pMalloc->Release();
        }
    }
    
    return bFolderSelected;
}

void CZipArchiveExplorerDlg::OnDeleteFiles() 
{
    ASSERT(m_pZipArchive != NULL);
    
    if ( m_pZipArchive == NULL )
        return;
        
    int nAnswer = MessageBox( "Delete files from archive?", AfxGetAppName(), MB_YESNOCANCEL|MB_DEFBUTTON2|MB_ICONQUESTION );
    
    if ( nAnswer == IDYES )
    {
        try
        {
            CStringArray arrayFilesToDelete;
            POSITION posItem = m_ctlContent.GetFirstSelectedItemPosition();
            while ( posItem != NULL )
            {
                int nItem = m_ctlContent.GetNextSelectedItem( posItem );
                const CZipFile& zipFile = m_pZipArchive->GetZipFile( nItem );
                arrayFilesToDelete.Add( zipFile.GetFilename() );
            }

            CWaitCursor wait;
            m_ctlOperation.SetWindowText( "Del" );
            m_pZipArchive->Delete( arrayFilesToDelete );
        }
        catch ( ... )
        {
            MessageBox( "Delete failed.\t", AfxGetAppName(), MB_ICONSTOP );
        }

        ResetProgressStatus();
        DisplayArchiveContent();
        UpdateButtonStatus();
    }
}
 
void CZipArchiveExplorerDlg::OnRclickArchiveContent(NMHDR* pNMHDR, LRESULT* pResult) 
{
    CMenu menuPopup;
    
    menuPopup.CreatePopupMenu();

    if ( m_pZipArchive != NULL )
        menuPopup.AppendMenu( MF_STRING, IDC_ADDFILES, (LPCTSTR)"Add..." );
    else
        menuPopup.AppendMenu( MF_STRING|MF_GRAYED, IDC_ADDFILES, (LPCTSTR)"Add..." );        
            
    if ( m_ctlContent.GetSelectedCount() > 0 )
    {
        menuPopup.AppendMenu( MF_STRING, IDC_EXTRACTFILES, (LPCTSTR)"Extract..." );
        menuPopup.AppendMenu( MF_STRING, IDC_DELETEFILES, (LPCTSTR)"Delete" );        
    }            
    else
    {
        menuPopup.AppendMenu( MF_STRING|MF_GRAYED, IDC_EXTRACTFILES, (LPCTSTR)"Extract..." );
        menuPopup.AppendMenu( MF_STRING|MF_GRAYED, IDC_DELETEFILES, (LPCTSTR)"Delete" );        
    }        
    
    menuPopup.AppendMenu( MF_SEPARATOR );

    if ( m_ctlContent.GetItemCount() > 0 )        
        menuPopup.AppendMenu( MF_STRING, IDC_SELECTALL, (LPCTSTR)"Select All" );
    else
        menuPopup.AppendMenu( MF_STRING|MF_GRAYED, IDC_SELECTALL, (LPCTSTR)"Select All" );    

    POINT pt;
    GetCursorPos( &pt );
    menuPopup.TrackPopupMenu( TPM_LEFTALIGN, pt.x, pt.y, this );
        
	*pResult = 0;
}

void CZipArchiveExplorerDlg::OnSelectAll() 
{
    for( int i = 0; i < m_ctlContent.GetItemCount(); i++ )
	{
		UINT prevState = m_ctlContent.GetItemState( i, (UINT)-1 );
		m_ctlContent.SetItemState( i, prevState | LVIS_SELECTED, (UINT)-1 );
	}
}



