// ZipArchiveExplorerDlg.h : header file
//

#if !defined(AFX_ZIPARCHIVEDEMODLG_H__FD9985C7_D566_11D2_B91B_006097630EBB__INCLUDED_)
#define AFX_ZIPARCHIVEDEMODLG_H__FD9985C7_D566_11D2_B91B_006097630EBB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CZipArchiveExplorerDlg dialog
#include "ZipArchive.h"

class CZipArchiveExplorerDlg : public CDialog, private CZipArchiveTarget
{
public:
	CZipArchiveExplorerDlg(CWnd* pParent = NULL);
    virtual ~CZipArchiveExplorerDlg();

	//{{AFX_DATA(CZipArchiveExplorerDlg)
	enum { IDD = IDD_ZIPARCHIVEEXPLORER_DIALOG };
	CButton	m_btnDeleteFiles;
	CButton	m_btnCloseArchive;
	CStatic	m_ctlOperation;
	CStatic	m_ctlCurrentFile;
	CProgressCtrl	m_ctlProgress;
	CButton	m_btnOpenArchive;
	CButton	m_btnNewArchive;
	CButton	m_btnExtractFiles;
	CButton	m_btnAddFiles;
	CListCtrl	m_ctlContent;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CZipArchiveExplorerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

    virtual bool OnArchiveProgress( const CString& strFilename, DWORD dwCurrent, DWORD dwTotal ); 
protected:
	HICON m_hIcon;

    enum columns { columnName, columnExt, columnDate, columnSizeNorm, columnSizeComp, columnAttr, columnCRC, columnPath };

	//{{AFX_MSG(CZipArchiveExplorerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNewArchive();
	afx_msg void OnOpenArchive();    
	afx_msg void OnAddFiles();
	afx_msg void OnArchiveContentItemChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCloseArchive();
	afx_msg void OnExtractFiles();
	afx_msg void OnRclickArchiveContent(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelectAll();
	afx_msg void OnDeleteFiles();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    void InitContent();
    void UpdateButtonStatus();
    void DisplayTitle();
    
    bool CreateArchive( const CString& strArchiveName );
    bool OpenArchive( const CString& strArchiveName );

    void InsertSubdirectoryItem( int nItemPos, const CZipFile& zipFile );
    void InsertFileItem( int nItemPos, const CZipFile& zipFile );
    CString GetDateTimeAsString( const DOSDATE& dosDate, const DOSTIME& dosTime ) const;
    CString GetAttributesAsString( BYTE bAttributes ) const;
    
	bool BrowseForFolder( CString& strFolder );
    static int CALLBACK BrowseCallbackProc( HWND hwnd, UINT uMsg, LPARAM lp, LPARAM pData );
	
    void ResetProgressStatus();
    void DisplayArchiveContent();
    bool ProcessQueuedMessages();
	    
private:	
	CZipArchive * m_pZipArchive;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZIPARCHIVEDEMODLG_H__FD9985C7_D566_11D2_B91B_006097630EBB__INCLUDED_)
